unit KEYHOLELib_TLB;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.
// ************************************************************************ //

// PASTLWTR : 1.2
// File generated on 25/03/2006 8.38.39 from Type Library described below.

// ************************************************************************  //
// Type Lib: C:\Programmi\Google\Google Earth\GoogleEarth.exe (1)
// LIBID: {3476FAB2-687F-4EA6-9AC2-88D72DC7D7FC}
// LCID: 0
// Helpfile:
// HelpString: Keyhole 1.0 Type Library
// DepndLst: 
//   (1) v2.0 stdole, (C:\WINDOWS\system32\stdole2.tlb)
// ************************************************************************ //
// *************************************************************************//
// NOTE:                                                                      
// Items guarded by $IFDEF_LIVE_SERVER_AT_DESIGN_TIME are used by properties  
// which return objects that may need to be explicitly created via a function 
// call prior to any access via the property. These items have been disabled  
// in order to prevent accidental use from within the object inspector. You   
// may enable them by defining LIVE_SERVER_AT_DESIGN_TIME or by selectively   
// removing them from the $IFDEF blocks. However, such items must still be    
// programmatically created via a method of the appropriate CoClass before    
// they can be used.                                                          
{$TYPEDADDRESS OFF} // Unit must be compiled without type-checked pointers. 
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  KEYHOLELibMajorVersion = 1;
  KEYHOLELibMinorVersion = 0;

  LIBID_KEYHOLELib: TGUID = '{3476FAB2-687F-4EA6-9AC2-88D72DC7D7FC}';

  IID_IKHInterface: TGUID = '{80A43F86-E2CD-4671-A7FA-E5627B519711}';
  CLASS_KHInterface: TGUID = '{AFD07A5E-3E20-4D77-825C-2F6D1A50BE5B}';
  IID_IKHViewInfo: TGUID = '{45F89E39-7A46-4CA4-97E3-8C5AA252531C}';
  IID_IKHViewExtents: TGUID = '{D05D6E91-72DA-4654-B8A7-BCBD3B87E3B6}';
  IID_IKHFeature: TGUID = '{07F46615-1857-40CF-9AA9-872C9858E769}';
  CLASS_KHViewInfo: TGUID = '{A2D4475B-C9AA-48E2-A029-1DB829DACF7B}';
  CLASS_KHViewExtents: TGUID = '{63E6BE14-A742-4EEA-8AF3-0EC39F10F850}';
  CLASS_KHFeature: TGUID = '{B153D707-447A-4538-913E-6146B3FDEE02}';
type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IKHInterface = interface;
  IKHInterfaceDisp = dispinterface;
  IKHViewInfo = interface;
  IKHViewInfoDisp = dispinterface;
  IKHViewExtents = interface;
  IKHViewExtentsDisp = dispinterface;
  IKHFeature = interface;
  IKHFeatureDisp = dispinterface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  KHInterface = IKHInterface;
  KHViewInfo = IKHViewInfo;
  KHViewExtents = IKHViewExtents;
  KHFeature = IKHFeature;


// *********************************************************************//
// Declaration of structures, unions and aliases.                         
// *********************************************************************//
  PWideString1 = ^WideString; {*}


// *********************************************************************//
// Interface: IKHInterface
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {80A43F86-E2CD-4671-A7FA-E5627B519711}
// *********************************************************************//
  IKHInterface = interface(IDispatch)
    ['{80A43F86-E2CD-4671-A7FA-E5627B519711}']
    function currentView(terrain: Integer): IKHViewInfo; safecall;
    function Get_streamingProgressPercentage: Integer; safecall;
    procedure SaveScreenShot(const fileName: WideString; quality: Integer); safecall;
    procedure OpenFile(const fileName: WideString); safecall;
    procedure QuitApplication; safecall;
    procedure SetRenderWindowSize(width: Integer; height: Integer); safecall;
    function Get_autopilotSpeed: Double; safecall;
    procedure Set_autopilotSpeed(pVal: Double); safecall;
    function Get_currentViewExtents: IKHViewExtents; safecall;
    procedure setView(const view: IKHViewInfo; terrain: Integer; speed: Double); safecall;
    procedure LoadKml(var kmlData: WideString); safecall;
    function getFeatureByName(const name: WideString): IKHFeature; safecall;
    procedure setViewParams(lat: Double; lon: Double; range: Double; tilt: Double; azimuth: Double; 
                            terrain: Integer; speed: Double); safecall;
    procedure setFeatureView(const feature: IKHFeature; speed: Double); safecall;
    function getPointOnTerrainFromScreenCoords(screen_x: Double; screen_y: Double): PSafeArray; safecall;
    property streamingProgressPercentage: Integer read Get_streamingProgressPercentage;
    property autopilotSpeed: Double read Get_autopilotSpeed write Set_autopilotSpeed;
    property currentViewExtents: IKHViewExtents read Get_currentViewExtents;
  end;

// *********************************************************************//
// DispIntf:  IKHInterfaceDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {80A43F86-E2CD-4671-A7FA-E5627B519711}
// *********************************************************************//
  IKHInterfaceDisp = dispinterface
    ['{80A43F86-E2CD-4671-A7FA-E5627B519711}']
    function currentView(terrain: Integer): IKHViewInfo; dispid 2;
    property streamingProgressPercentage: Integer readonly dispid 3;
    procedure SaveScreenShot(const fileName: WideString; quality: Integer); dispid 4;
    procedure OpenFile(const fileName: WideString); dispid 5;
    procedure QuitApplication; dispid 6;
    procedure SetRenderWindowSize(width: Integer; height: Integer); dispid 7;
    property autopilotSpeed: Double dispid 9;
    property currentViewExtents: IKHViewExtents readonly dispid 10;
    procedure setView(const view: IKHViewInfo; terrain: Integer; speed: Double); dispid 11;
    procedure LoadKml(var kmlData: WideString); dispid 12;
    function getFeatureByName(const name: WideString): IKHFeature; dispid 13;
    procedure setViewParams(lat: Double; lon: Double; range: Double; tilt: Double; azimuth: Double;terrain: Integer; speed: Double); dispid 14;
    procedure setFeatureView(const feature: IKHFeature; speed: Double); dispid 15;
    function getPointOnTerrainFromScreenCoords(screen_x: Double; screen_y: Double): {??PSafeArray}OleVariant; dispid 16;
  end;

// *********************************************************************//
// Interface: IKHViewInfo
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {45F89E39-7A46-4CA4-97E3-8C5AA252531C}
// *********************************************************************//
  IKHViewInfo = interface(IDispatch)
    ['{45F89E39-7A46-4CA4-97E3-8C5AA252531C}']
    function Get_latitude: Double; safecall;
    procedure Set_latitude(pLat: Double); safecall;
    function Get_longitude: Double; safecall;
    procedure Set_longitude(pLon: Double); safecall;
    function Get_range: Double; safecall;
    procedure Set_range(pRange: Double); safecall;
    function Get_tilt: Double; safecall;
    procedure Set_tilt(pTilt: Double); safecall;
    function Get_azimuth: Double; safecall;
    procedure Set_azimuth(pAzimuth: Double); safecall;
    property latitude: Double read Get_latitude write Set_latitude;
    property longitude: Double read Get_longitude write Set_longitude;
    property range: Double read Get_range write Set_range;
    property tilt: Double read Get_tilt write Set_tilt;
    property azimuth: Double read Get_azimuth write Set_azimuth;
  end;

// *********************************************************************//
// DispIntf:  IKHViewInfoDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {45F89E39-7A46-4CA4-97E3-8C5AA252531C}
// *********************************************************************//
  IKHViewInfoDisp = dispinterface
    ['{45F89E39-7A46-4CA4-97E3-8C5AA252531C}']
    property latitude: Double dispid 1;
    property longitude: Double dispid 2;
    property range: Double dispid 3;
    property tilt: Double dispid 4;
    property azimuth: Double dispid 5;
  end;

// *********************************************************************//
// Interface: IKHViewExtents
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {D05D6E91-72DA-4654-B8A7-BCBD3B87E3B6}
// *********************************************************************//
  IKHViewExtents = interface(IDispatch)
    ['{D05D6E91-72DA-4654-B8A7-BCBD3B87E3B6}']
    function Get_north: Double; safecall;
    function Get_south: Double; safecall;
    function Get_east: Double; safecall;
    function Get_west: Double; safecall;
    property north: Double read Get_north;
    property south: Double read Get_south;
    property east: Double read Get_east;
    property west: Double read Get_west;
  end;

// *********************************************************************//
// DispIntf:  IKHViewExtentsDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {D05D6E91-72DA-4654-B8A7-BCBD3B87E3B6}
// *********************************************************************//
  IKHViewExtentsDisp = dispinterface
    ['{D05D6E91-72DA-4654-B8A7-BCBD3B87E3B6}']
    property north: Double readonly dispid 1;
    property south: Double readonly dispid 2;
    property east: Double readonly dispid 3;
    property west: Double readonly dispid 4;
  end;

// *********************************************************************//
// Interface: IKHFeature
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {07F46615-1857-40CF-9AA9-872C9858E769}
// *********************************************************************//
  IKHFeature = interface(IDispatch)
    ['{07F46615-1857-40CF-9AA9-872C9858E769}']
    function Get_visibility: Integer; safecall;
    procedure Set_visibility(pVal: Integer); safecall;
    function Get_hasView: Integer; safecall;
    property visibility: Integer read Get_visibility write Set_visibility;
    property hasView: Integer read Get_hasView;
  end;

// *********************************************************************//
// DispIntf:  IKHFeatureDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {07F46615-1857-40CF-9AA9-872C9858E769}
// *********************************************************************//
  IKHFeatureDisp = dispinterface
    ['{07F46615-1857-40CF-9AA9-872C9858E769}']
    property visibility: Integer dispid 1;
    property hasView: Integer readonly dispid 2;
  end;

// *********************************************************************//
// The Class CoKHInterface provides a Create and CreateRemote method to          
// create instances of the default interface IKHInterface exposed by              
// the CoClass KHInterface. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoKHInterface = class
    class function Create: IKHInterface;
    class function CreateRemote(const MachineName: string): IKHInterface;
  end;


// *********************************************************************//
// OLE Server Proxy class declaration
// Server Object    : TKHInterface
// Help String      : KHInterface Class
// Default Interface: IKHInterface
// Def. Intf. DISP? : No
// Event   Interface: 
// TypeFlags        : (2) CanCreate
// *********************************************************************//
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  TKHInterfaceProperties= class;
{$ENDIF}
  TKHInterface = class(TOleServer)
  private
    FIntf:        IKHInterface;
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
    FProps:       TKHInterfaceProperties;
    function      GetServerProperties: TKHInterfaceProperties;
{$ENDIF}
    function      GetDefaultInterface: IKHInterface;
  protected
    procedure InitServerData; override;
    function Get_streamingProgressPercentage: Integer;
    function Get_autopilotSpeed: Double;
    procedure Set_autopilotSpeed(pVal: Double);
    function Get_currentViewExtents: IKHViewExtents;
  public
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;
    procedure Connect; override;
    procedure ConnectTo(svrIntf: IKHInterface);
    procedure Disconnect; override;
    function currentView(terrain: Integer): IKHViewInfo;
    procedure SaveScreenShot(const fileName: WideString; quality: Integer);
    procedure OpenFile(const fileName: WideString);
    procedure QuitApplication;
    procedure SetRenderWindowSize(width: Integer; height: Integer);
    procedure setView(const view: IKHViewInfo; terrain: Integer; speed: Double);
    procedure LoadKml(var kmlData: WideString);
    function getFeatureByName(const name: WideString): IKHFeature;
    procedure setViewParams(lat: Double; lon: Double; range: Double; tilt: Double; azimuth: Double;
                            terrain: Integer; speed: Double);
    procedure setFeatureView(const feature: IKHFeature; speed: Double);
    function getPointOnTerrainFromScreenCoords(screen_x: Double; screen_y: Double): PSafeArray;
    property DefaultInterface: IKHInterface read GetDefaultInterface;
    property streamingProgressPercentage: Integer read Get_streamingProgressPercentage;
    property currentViewExtents: IKHViewExtents read Get_currentViewExtents;
    property autopilotSpeed: Double read Get_autopilotSpeed write Set_autopilotSpeed;
  published
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
    property Server: TKHInterfaceProperties read GetServerProperties;
{$ENDIF}
  end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
// *********************************************************************//
// OLE Server Properties Proxy Class
// Server Object    : TKHInterface
// (This object is used by the IDE's Property Inspector to allow editing
//  of the properties of this server)
// *********************************************************************//
 TKHInterfaceProperties = class(TPersistent)
  private
    FServer:    TKHInterface;
    function    GetDefaultInterface: IKHInterface;
    constructor Create(AServer: TKHInterface);
  protected
    function Get_streamingProgressPercentage: Integer;
    function Get_autopilotSpeed: Double;
    procedure Set_autopilotSpeed(pVal: Double);
    function Get_currentViewExtents: IKHViewExtents;
  public
    property DefaultInterface: IKHInterface read GetDefaultInterface;
  published
    property autopilotSpeed: Double read Get_autopilotSpeed write Set_autopilotSpeed;
  end;
{$ENDIF}


// *********************************************************************//
// The Class CoKHViewInfo provides a Create and CreateRemote method to          
// create instances of the default interface IKHViewInfo exposed by              
// the CoClass KHViewInfo. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoKHViewInfo = class
    class function Create: IKHViewInfo;
    class function CreateRemote(const MachineName: string): IKHViewInfo;
  end;


// *********************************************************************//
// OLE Server Proxy class declaration
// Server Object    : TKHViewInfo
// Help String      : KHViewInfo Class
// Default Interface: IKHViewInfo
// Def. Intf. DISP? : No
// Event   Interface: 
// TypeFlags        : (2) CanCreate
// *********************************************************************//
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  TKHViewInfoProperties= class;
{$ENDIF}
  TKHViewInfo = class(TOleServer)
  private
    FIntf:        IKHViewInfo;
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
    FProps:       TKHViewInfoProperties;
    function      GetServerProperties: TKHViewInfoProperties;
{$ENDIF}
    function      GetDefaultInterface: IKHViewInfo;
  protected
    procedure InitServerData; override;
    function Get_latitude: Double;
    procedure Set_latitude(pLat: Double);
    function Get_longitude: Double;
    procedure Set_longitude(pLon: Double);
    function Get_range: Double;
    procedure Set_range(pRange: Double);
    function Get_tilt: Double;
    procedure Set_tilt(pTilt: Double);
    function Get_azimuth: Double;
    procedure Set_azimuth(pAzimuth: Double);
  public
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;
    procedure Connect; override;
    procedure ConnectTo(svrIntf: IKHViewInfo);
    procedure Disconnect; override;
    property DefaultInterface: IKHViewInfo read GetDefaultInterface;
    property latitude: Double read Get_latitude write Set_latitude;
    property longitude: Double read Get_longitude write Set_longitude;
    property range: Double read Get_range write Set_range;
    property tilt: Double read Get_tilt write Set_tilt;
    property azimuth: Double read Get_azimuth write Set_azimuth;
  published
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
    property Server: TKHViewInfoProperties read GetServerProperties;
{$ENDIF}
  end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
// *********************************************************************//
// OLE Server Properties Proxy Class
// Server Object    : TKHViewInfo
// (This object is used by the IDE's Property Inspector to allow editing
//  of the properties of this server)
// *********************************************************************//
 TKHViewInfoProperties = class(TPersistent)
  private
    FServer:    TKHViewInfo;
    function    GetDefaultInterface: IKHViewInfo;
    constructor Create(AServer: TKHViewInfo);
  protected
    function Get_latitude: Double;
    procedure Set_latitude(pLat: Double);
    function Get_longitude: Double;
    procedure Set_longitude(pLon: Double);
    function Get_range: Double;
    procedure Set_range(pRange: Double);
    function Get_tilt: Double;
    procedure Set_tilt(pTilt: Double);
    function Get_azimuth: Double;
    procedure Set_azimuth(pAzimuth: Double);
  public
    property DefaultInterface: IKHViewInfo read GetDefaultInterface;
  published
    property latitude: Double read Get_latitude write Set_latitude;
    property longitude: Double read Get_longitude write Set_longitude;
    property range: Double read Get_range write Set_range;
    property tilt: Double read Get_tilt write Set_tilt;
    property azimuth: Double read Get_azimuth write Set_azimuth;
  end;
{$ENDIF}


// *********************************************************************//
// The Class CoKHViewExtents provides a Create and CreateRemote method to          
// create instances of the default interface IKHViewExtents exposed by              
// the CoClass KHViewExtents. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoKHViewExtents = class
    class function Create: IKHViewExtents;
    class function CreateRemote(const MachineName: string): IKHViewExtents;
  end;


// *********************************************************************//
// OLE Server Proxy class declaration
// Server Object    : TKHViewExtents
// Help String      : KHViewExtents Class
// Default Interface: IKHViewExtents
// Def. Intf. DISP? : No
// Event   Interface: 
// TypeFlags        : (2) CanCreate
// *********************************************************************//
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  TKHViewExtentsProperties= class;
{$ENDIF}
  TKHViewExtents = class(TOleServer)
  private
    FIntf:        IKHViewExtents;
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
    FProps:       TKHViewExtentsProperties;
    function      GetServerProperties: TKHViewExtentsProperties;
{$ENDIF}
    function      GetDefaultInterface: IKHViewExtents;
  protected
    procedure InitServerData; override;
    function Get_north: Double;
    function Get_south: Double;
    function Get_east: Double;
    function Get_west: Double;
  public
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;
    procedure Connect; override;
    procedure ConnectTo(svrIntf: IKHViewExtents);
    procedure Disconnect; override;
    property DefaultInterface: IKHViewExtents read GetDefaultInterface;
    property north: Double read Get_north;
    property south: Double read Get_south;
    property east: Double read Get_east;
    property west: Double read Get_west;
  published
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
    property Server: TKHViewExtentsProperties read GetServerProperties;
{$ENDIF}
  end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
// *********************************************************************//
// OLE Server Properties Proxy Class
// Server Object    : TKHViewExtents
// (This object is used by the IDE's Property Inspector to allow editing
//  of the properties of this server)
// *********************************************************************//
 TKHViewExtentsProperties = class(TPersistent)
  private
    FServer:    TKHViewExtents;
    function    GetDefaultInterface: IKHViewExtents;
    constructor Create(AServer: TKHViewExtents);
  protected
    function Get_north: Double;
    function Get_south: Double;
    function Get_east: Double;
    function Get_west: Double;
  public
    property DefaultInterface: IKHViewExtents read GetDefaultInterface;
  published
  end;
{$ENDIF}


// *********************************************************************//
// The Class CoKHFeature provides a Create and CreateRemote method to          
// create instances of the default interface IKHFeature exposed by              
// the CoClass KHFeature. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CoKHFeature = class
    class function Create: IKHFeature;
    class function CreateRemote(const MachineName: string): IKHFeature;
  end;


// *********************************************************************//
// OLE Server Proxy class declaration
// Server Object    : TKHFeature
// Help String      : KHFeature Class
// Default Interface: IKHFeature
// Def. Intf. DISP? : No
// Event   Interface: 
// TypeFlags        : (2) CanCreate
// *********************************************************************//
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  TKHFeatureProperties= class;
{$ENDIF}
  TKHFeature = class(TOleServer)
  private
    FIntf:        IKHFeature;
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
    FProps:       TKHFeatureProperties;
    function      GetServerProperties: TKHFeatureProperties;
{$ENDIF}
    function      GetDefaultInterface: IKHFeature;
  protected
    procedure InitServerData; override;
    function Get_visibility: Integer;
    procedure Set_visibility(pVal: Integer);
    function Get_hasView: Integer;
  public
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;
    procedure Connect; override;
    procedure ConnectTo(svrIntf: IKHFeature);
    procedure Disconnect; override;
    property DefaultInterface: IKHFeature read GetDefaultInterface;
    property hasView: Integer read Get_hasView;
    property visibility: Integer read Get_visibility write Set_visibility;
  published
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
    property Server: TKHFeatureProperties read GetServerProperties;
{$ENDIF}
  end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
// *********************************************************************//
// OLE Server Properties Proxy Class
// Server Object    : TKHFeature
// (This object is used by the IDE's Property Inspector to allow editing
//  of the properties of this server)
// *********************************************************************//
 TKHFeatureProperties = class(TPersistent)
  private
    FServer:    TKHFeature;
    function    GetDefaultInterface: IKHFeature;
    constructor Create(AServer: TKHFeature);
  protected
    function Get_visibility: Integer;
    procedure Set_visibility(pVal: Integer);
    function Get_hasView: Integer;
  public
    property DefaultInterface: IKHFeature read GetDefaultInterface;
  published
    property visibility: Integer read Get_visibility write Set_visibility;
  end;
{$ENDIF}


procedure Register;

resourcestring
  dtlServerPage = 'Internet';
  dtlOcxPage = 'Internet';

implementation

uses ComObj;

class function CoKHInterface.Create: IKHInterface;
begin
  Result := CreateComObject(CLASS_KHInterface) as IKHInterface;
end;

class function CoKHInterface.CreateRemote(const MachineName: string): IKHInterface;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_KHInterface) as IKHInterface;
end;

procedure TKHInterface.InitServerData;
const
  CServerData: TServerData = (
    ClassID:   '{AFD07A5E-3E20-4D77-825C-2F6D1A50BE5B}';
    IntfIID:   '{80A43F86-E2CD-4671-A7FA-E5627B519711}';
    EventIID:  '';
    LicenseKey: nil;
    Version: 500);
begin
  ServerData := @CServerData;
end;

procedure TKHInterface.Connect;
var
  punk: IUnknown;
begin
  if FIntf = nil then
  begin
    punk := GetServer;
    Fintf:= punk as IKHInterface;
  end;
end;

procedure TKHInterface.ConnectTo(svrIntf: IKHInterface);
begin
  Disconnect;
  FIntf := svrIntf;
end;

procedure TKHInterface.DisConnect;
begin
  if Fintf <> nil then
  begin
    FIntf := nil;
  end;
end;

function TKHInterface.GetDefaultInterface: IKHInterface;
begin
  if FIntf = nil then
    Connect;
  Assert(FIntf <> nil, 'DefaultInterface is NULL. Component is not connected to Server. You must call ''Connect'' or ''ConnectTo'' before this operation');
  Result := FIntf;
end;

constructor TKHInterface.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  FProps := TKHInterfaceProperties.Create(Self);
{$ENDIF}
end;

destructor TKHInterface.Destroy;
begin
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  FProps.Free;
{$ENDIF}
  inherited Destroy;
end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
function TKHInterface.GetServerProperties: TKHInterfaceProperties;
begin
  Result := FProps;
end;
{$ENDIF}

function TKHInterface.Get_streamingProgressPercentage: Integer;
begin
    Result := DefaultInterface.streamingProgressPercentage;
end;

function TKHInterface.Get_autopilotSpeed: Double;
begin
    Result := DefaultInterface.autopilotSpeed;
end;

procedure TKHInterface.Set_autopilotSpeed(pVal: Double);
begin
  DefaultInterface.Set_autopilotSpeed(pVal);
end;

function TKHInterface.Get_currentViewExtents: IKHViewExtents;
begin
    Result := DefaultInterface.currentViewExtents;
end;

function TKHInterface.currentView(terrain: Integer): IKHViewInfo;
begin
  Result := DefaultInterface.currentView(terrain);
end;

procedure TKHInterface.SaveScreenShot(const fileName: WideString; quality: Integer);
begin
  DefaultInterface.SaveScreenShot(fileName, quality);
end;

procedure TKHInterface.OpenFile(const fileName: WideString);
begin
  DefaultInterface.OpenFile(fileName);
end;

procedure TKHInterface.QuitApplication;
begin
  DefaultInterface.QuitApplication;
end;

procedure TKHInterface.SetRenderWindowSize(width: Integer; height: Integer);
begin
  DefaultInterface.SetRenderWindowSize(width, height);
end;

procedure TKHInterface.setView(const view: IKHViewInfo; terrain: Integer; speed: Double);
begin
  DefaultInterface.setView(view, terrain, speed);
end;

procedure TKHInterface.LoadKml(var kmlData: WideString);
begin
  DefaultInterface.LoadKml(kmlData);
end;

function TKHInterface.getFeatureByName(const name: WideString): IKHFeature;
begin
  Result := DefaultInterface.getFeatureByName(name);
end;

procedure TKHInterface.setViewParams(lat: Double; lon: Double; range: Double; tilt: Double; 
                                     azimuth: Double; terrain: Integer; speed: Double);
begin
  DefaultInterface.setViewParams(lat, lon, range, tilt, azimuth, terrain, speed);
end;

procedure TKHInterface.setFeatureView(const feature: IKHFeature; speed: Double);
begin
  DefaultInterface.setFeatureView(feature, speed);
end;

function TKHInterface.getPointOnTerrainFromScreenCoords(screen_x: Double; screen_y: Double): PSafeArray;
begin
  Result := DefaultInterface.getPointOnTerrainFromScreenCoords(screen_x, screen_y);
end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
constructor TKHInterfaceProperties.Create(AServer: TKHInterface);
begin
  inherited Create;
  FServer := AServer;
end;

function TKHInterfaceProperties.GetDefaultInterface: IKHInterface;
begin
  Result := FServer.DefaultInterface;
end;

function TKHInterfaceProperties.Get_streamingProgressPercentage: Integer;
begin
    Result := DefaultInterface.streamingProgressPercentage;
end;

function TKHInterfaceProperties.Get_autopilotSpeed: Double;
begin
    Result := DefaultInterface.autopilotSpeed;
end;

procedure TKHInterfaceProperties.Set_autopilotSpeed(pVal: Double);
begin
  DefaultInterface.Set_autopilotSpeed(pVal);
end;

function TKHInterfaceProperties.Get_currentViewExtents: IKHViewExtents;
begin
    Result := DefaultInterface.currentViewExtents;
end;

{$ENDIF}

class function CoKHViewInfo.Create: IKHViewInfo;
begin
  Result := CreateComObject(CLASS_KHViewInfo) as IKHViewInfo;
end;

class function CoKHViewInfo.CreateRemote(const MachineName: string): IKHViewInfo;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_KHViewInfo) as IKHViewInfo;
end;

procedure TKHViewInfo.InitServerData;
const
  CServerData: TServerData = (
    ClassID:   '{A2D4475B-C9AA-48E2-A029-1DB829DACF7B}';
    IntfIID:   '{45F89E39-7A46-4CA4-97E3-8C5AA252531C}';
    EventIID:  '';
    LicenseKey: nil;
    Version: 500);
begin
  ServerData := @CServerData;
end;

procedure TKHViewInfo.Connect;
var
  punk: IUnknown;
begin
  if FIntf = nil then
  begin
    punk := GetServer;
    Fintf:= punk as IKHViewInfo;
  end;
end;

procedure TKHViewInfo.ConnectTo(svrIntf: IKHViewInfo);
begin
  Disconnect;
  FIntf := svrIntf;
end;

procedure TKHViewInfo.DisConnect;
begin
  if Fintf <> nil then
  begin
    FIntf := nil;
  end;
end;

function TKHViewInfo.GetDefaultInterface: IKHViewInfo;
begin
  if FIntf = nil then
    Connect;
  Assert(FIntf <> nil, 'DefaultInterface is NULL. Component is not connected to Server. You must call ''Connect'' or ''ConnectTo'' before this operation');
  Result := FIntf;
end;

constructor TKHViewInfo.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  FProps := TKHViewInfoProperties.Create(Self);
{$ENDIF}
end;

destructor TKHViewInfo.Destroy;
begin
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  FProps.Free;
{$ENDIF}
  inherited Destroy;
end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
function TKHViewInfo.GetServerProperties: TKHViewInfoProperties;
begin
  Result := FProps;
end;
{$ENDIF}

function TKHViewInfo.Get_latitude: Double;
begin
    Result := DefaultInterface.latitude;
end;

procedure TKHViewInfo.Set_latitude(pLat: Double);
begin
  DefaultInterface.Set_latitude(pLat);
end;

function TKHViewInfo.Get_longitude: Double;
begin
    Result := DefaultInterface.longitude;
end;

procedure TKHViewInfo.Set_longitude(pLon: Double);
begin
  DefaultInterface.Set_longitude(pLon);
end;

function TKHViewInfo.Get_range: Double;
begin
    Result := DefaultInterface.range;
end;

procedure TKHViewInfo.Set_range(pRange: Double);
begin
  DefaultInterface.Set_range(pRange);
end;

function TKHViewInfo.Get_tilt: Double;
begin
    Result := DefaultInterface.tilt;
end;

procedure TKHViewInfo.Set_tilt(pTilt: Double);
begin
  DefaultInterface.Set_tilt(pTilt);
end;

function TKHViewInfo.Get_azimuth: Double;
begin
    Result := DefaultInterface.azimuth;
end;

procedure TKHViewInfo.Set_azimuth(pAzimuth: Double);
begin
  DefaultInterface.Set_azimuth(pAzimuth);
end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
constructor TKHViewInfoProperties.Create(AServer: TKHViewInfo);
begin
  inherited Create;
  FServer := AServer;
end;

function TKHViewInfoProperties.GetDefaultInterface: IKHViewInfo;
begin
  Result := FServer.DefaultInterface;
end;

function TKHViewInfoProperties.Get_latitude: Double;
begin
    Result := DefaultInterface.latitude;
end;

procedure TKHViewInfoProperties.Set_latitude(pLat: Double);
begin
  DefaultInterface.Set_latitude(pLat);
end;

function TKHViewInfoProperties.Get_longitude: Double;
begin
    Result := DefaultInterface.longitude;
end;

procedure TKHViewInfoProperties.Set_longitude(pLon: Double);
begin
  DefaultInterface.Set_longitude(pLon);
end;

function TKHViewInfoProperties.Get_range: Double;
begin
    Result := DefaultInterface.range;
end;

procedure TKHViewInfoProperties.Set_range(pRange: Double);
begin
  DefaultInterface.Set_range(pRange);
end;

function TKHViewInfoProperties.Get_tilt: Double;
begin
    Result := DefaultInterface.tilt;
end;

procedure TKHViewInfoProperties.Set_tilt(pTilt: Double);
begin
  DefaultInterface.Set_tilt(pTilt);
end;

function TKHViewInfoProperties.Get_azimuth: Double;
begin
    Result := DefaultInterface.azimuth;
end;

procedure TKHViewInfoProperties.Set_azimuth(pAzimuth: Double);
begin
  DefaultInterface.Set_azimuth(pAzimuth);
end;

{$ENDIF}

class function CoKHViewExtents.Create: IKHViewExtents;
begin
  Result := CreateComObject(CLASS_KHViewExtents) as IKHViewExtents;
end;

class function CoKHViewExtents.CreateRemote(const MachineName: string): IKHViewExtents;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_KHViewExtents) as IKHViewExtents;
end;

procedure TKHViewExtents.InitServerData;
const
  CServerData: TServerData = (
    ClassID:   '{63E6BE14-A742-4EEA-8AF3-0EC39F10F850}';
    IntfIID:   '{D05D6E91-72DA-4654-B8A7-BCBD3B87E3B6}';
    EventIID:  '';
    LicenseKey: nil;
    Version: 500);
begin
  ServerData := @CServerData;
end;

procedure TKHViewExtents.Connect;
var
  punk: IUnknown;
begin
  if FIntf = nil then
  begin
    punk := GetServer;
    Fintf:= punk as IKHViewExtents;
  end;
end;

procedure TKHViewExtents.ConnectTo(svrIntf: IKHViewExtents);
begin
  Disconnect;
  FIntf := svrIntf;
end;

procedure TKHViewExtents.DisConnect;
begin
  if Fintf <> nil then
  begin
    FIntf := nil;
  end;
end;

function TKHViewExtents.GetDefaultInterface: IKHViewExtents;
begin
  if FIntf = nil then
    Connect;
  Assert(FIntf <> nil, 'DefaultInterface is NULL. Component is not connected to Server. You must call ''Connect'' or ''ConnectTo'' before this operation');
  Result := FIntf;
end;

constructor TKHViewExtents.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  FProps := TKHViewExtentsProperties.Create(Self);
{$ENDIF}
end;

destructor TKHViewExtents.Destroy;
begin
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  FProps.Free;
{$ENDIF}
  inherited Destroy;
end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
function TKHViewExtents.GetServerProperties: TKHViewExtentsProperties;
begin
  Result := FProps;
end;
{$ENDIF}

function TKHViewExtents.Get_north: Double;
begin
    Result := DefaultInterface.north;
end;

function TKHViewExtents.Get_south: Double;
begin
    Result := DefaultInterface.south;
end;

function TKHViewExtents.Get_east: Double;
begin
    Result := DefaultInterface.east;
end;

function TKHViewExtents.Get_west: Double;
begin
    Result := DefaultInterface.west;
end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
constructor TKHViewExtentsProperties.Create(AServer: TKHViewExtents);
begin
  inherited Create;
  FServer := AServer;
end;

function TKHViewExtentsProperties.GetDefaultInterface: IKHViewExtents;
begin
  Result := FServer.DefaultInterface;
end;

function TKHViewExtentsProperties.Get_north: Double;
begin
    Result := DefaultInterface.north;
end;

function TKHViewExtentsProperties.Get_south: Double;
begin
    Result := DefaultInterface.south;
end;

function TKHViewExtentsProperties.Get_east: Double;
begin
    Result := DefaultInterface.east;
end;

function TKHViewExtentsProperties.Get_west: Double;
begin
    Result := DefaultInterface.west;
end;

{$ENDIF}

class function CoKHFeature.Create: IKHFeature;
begin
  Result := CreateComObject(CLASS_KHFeature) as IKHFeature;
end;

class function CoKHFeature.CreateRemote(const MachineName: string): IKHFeature;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_KHFeature) as IKHFeature;
end;

procedure TKHFeature.InitServerData;
const
  CServerData: TServerData = (
    ClassID:   '{B153D707-447A-4538-913E-6146B3FDEE02}';
    IntfIID:   '{07F46615-1857-40CF-9AA9-872C9858E769}';
    EventIID:  '';
    LicenseKey: nil;
    Version: 500);
begin
  ServerData := @CServerData;
end;

procedure TKHFeature.Connect;
var
  punk: IUnknown;
begin
  if FIntf = nil then
  begin
    punk := GetServer;
    Fintf:= punk as IKHFeature;
  end;
end;

procedure TKHFeature.ConnectTo(svrIntf: IKHFeature);
begin
  Disconnect;
  FIntf := svrIntf;
end;

procedure TKHFeature.DisConnect;
begin
  if Fintf <> nil then
  begin
    FIntf := nil;
  end;
end;

function TKHFeature.GetDefaultInterface: IKHFeature;
begin
  if FIntf = nil then
    Connect;
  Assert(FIntf <> nil, 'DefaultInterface is NULL. Component is not connected to Server. You must call ''Connect'' or ''ConnectTo'' before this operation');
  Result := FIntf;
end;

constructor TKHFeature.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  FProps := TKHFeatureProperties.Create(Self);
{$ENDIF}
end;

destructor TKHFeature.Destroy;
begin
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  FProps.Free;
{$ENDIF}
  inherited Destroy;
end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
function TKHFeature.GetServerProperties: TKHFeatureProperties;
begin
  Result := FProps;
end;
{$ENDIF}

function TKHFeature.Get_visibility: Integer;
begin
    Result := DefaultInterface.visibility;
end;

procedure TKHFeature.Set_visibility(pVal: Integer);
begin
  DefaultInterface.Set_visibility(pVal);
end;

function TKHFeature.Get_hasView: Integer;
begin
    Result := DefaultInterface.hasView;
end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
constructor TKHFeatureProperties.Create(AServer: TKHFeature);
begin
  inherited Create;
  FServer := AServer;
end;

function TKHFeatureProperties.GetDefaultInterface: IKHFeature;
begin
  Result := FServer.DefaultInterface;
end;

function TKHFeatureProperties.Get_visibility: Integer;
begin
    Result := DefaultInterface.visibility;
end;

procedure TKHFeatureProperties.Set_visibility(pVal: Integer);
begin
  DefaultInterface.Set_visibility(pVal);
end;

function TKHFeatureProperties.Get_hasView: Integer;
begin
    Result := DefaultInterface.hasView;
end;

{$ENDIF}

procedure Register;
begin
  //RegisterComponents(dtlServerPage, [TKHInterface, TKHViewInfo, TKHViewExtents, TKHFeature]);
end;

end.
